
;--------------------------------------------------------------------------------------------
;Le programme lit en boucle  intervalles de temps rguliers l'entre analogique AN0
;et envoie les 8bits de poids forts du rsultat de la conversion  sur le port C
;Le Timer 3 est utilis pour fixer l'intervalle de temps entre 2 conversions
;Le programme scrute en permanence le timer 3  (on n'utilise pas les interruptions dans ce TP)
;--------------------------------------------------------------------------------------------

;***** Dsactiver le watchdog**********
            .section __FWDT.sec,code
            .global __FWDT
__FWDT:     .pword 0xFF7F
;**************************************

;***** Le programme *******************
            .global	__reset                 ;  Utilis par le fichier 33fj16mc304.gld pour implanter le programme
            .section    .text           ;  indique au  linker d'utiliser la mmoire programme pour la suite

;Adresses  ;Instructions                ; Commentaires
__reset:
            mov #0xF00,W15 				;  initialisation du pointeur de pile en haut de la RAM_Y 
            rcall   _init_timer3    	;  appel de sous-programmes
            rcall   _init_adc
            rcall   _init_PORTC
boucle1:
            clr TMR3					; remise  0 du Timer 3
            mov #0x200,W1
boucle2:
            mov TMR3,W0					; On reste dans la boucle 2
            sub W1,W0,W0 				; tant que le Timer 3
            bra GT,boucle2				; n'a pas atteint  0x200
            mov ADC1BUF0,W0				;lecture de l'entre analogique  AN0
            lsr W0,#8,W0				;dcalage  droite de huit bits
            mov W0,PORTC				;envoi  sur le port D
            bra boucle1					;on recommence  la ligne "boucle1"
;******************************************
;fin du_programme principal
;*******************************************
;*******************************************
;    Les sous-programmes
;*******************************************   
_init_PORTC:
            clr TRISC
            return
_init_timer3:
            mov #0x8000,W0
            mov W0,T3CON
            mov #0xFFFF,W0
            mov W0,PR3
            return
_init_adc:
            mov #0xFFFE,W0
            mov W0,AD1PCFGL
            mov #0x0000,W0
            mov W0,AD1CON2
            mov #0x010A,W0
            mov W0,AD1CON3
            mov #0x0000,W0
            mov W0,AD1CHS0
            mov #0x82E6,W0
            mov W0,AD1CON1
            return
            .end                           ; fin du fichier

